import numpy as np

A = np.array([168, 171, 168, 167, 164, 172, 154, 174, 166, 166])
B = np.array([185, 181, 180, 187, 176, 182, 171, 176, 176, 184])

def calc_t(X, Y):
    M = len(X)
    N = len(Y)
    df = M + N - 2
    meanX = X.mean()
    meanY = Y.mean()
    ss = (((X - meanX) ** 2).sum() + ((Y - meanY) ** 2).sum()) / df
    ss_XY = ss * (M + N) / (M * N)
    t = (meanX - meanY) / (ss_XY ** 0.5)
    return t, df

t, df = calc_t(A, B)
print('t = ',t, '　　自由度 = ', df)
