import numpy as np
import matplotlib.pyplot as plt
import scipy.stats
import seaborn

mu = 170
sgm = 6

data = scipy.stats.norm.rvs(loc = mu, scale = sgm, size = 10)
print(data)

data = []
for i in range(5):
    data.append(scipy.stats.norm.rvs(loc = mu, scale = sgm, size = 10))

Values = []
Groups = []
for i in range(5):
    Values += [v for v in data[i]]
    Groups += ['S-{}'.format(i + 1)] * len(data[i])
seaborn.stripplot(x = 'G', y = 'V', data = {'G': Groups, 'V': Values})
plt.show()

seaborn.boxplot(x = 'G', y = 'V', data = {'G': Groups, 'V': Values})
plt.show()
